function ApplyBotParts(%c,%b)
{
   %o = %c.player;
   %c.player = %b;
   %c.applyBodyParts();
   %c.applyBodyColors();
   %c.player = %o;
   return %b;
}
function AIPlayer::doLifeTick(%obj)
{
   cancel(%obj.lifesched);
   if(isObject(%mount=%obj.getObjectMount()))
   {
      if(isObject(%mount.client))
         %mount.client.bottomprint(
         "<font:impact:25>"@(%obj.name$="Badspot" //a fun little check, pardon my spaghetti code here
         ?"\c6Mother of God. It's \c3Badspot's Corpse\c6. You gotta handle this with care, man"
         :"\c6Body of \c3"@%obj.name@"\c6, killed by \c3"@%obj.killerName@"\c6."),0.2,1);
   }
   %obj.lifeSched=%obj.schedule(100,doLifeTick);
}
function Player::doCorpseClick(%this)
{
   if(isObject(%b=%this.getMountedObject(0))&&%b.corpse)
   {
      %b.dismount();
      %b.addVelocity(vectorScale(%this.getEyeVector(),5));
      %this.playThread(0,"root");
   }
   else
   {
      %start = %this.getEyePoint();
      %targets = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
      %vec =%this.getEyeVector();
      %end = vectorAdd(%start,vectorScale(%vec,10));
      %ray = containerRaycast(%start,%end,%targets,%this);
      %col = firstWord(%ray);
      if(!isObject(%col))
         return;
      if(%col.getClassName()!$="AIPlayer"||!%col.corpse)
         return;
      if(isObject(%mount=%col.getObjectMount()))
         %mount.playThread(0,"root");
      %this.mountObject(%col,1);
      %col.setTransform("0 0 0 0 0 -1 1.5709");
      %this.playThread(0,"ArmReadyBoth");
   }
   
}
function AIPlayer::doNiceRemove(%obj)
{
   if(isObject(%mount=%obj.getObjectMount()))
      %mount.playThread(0,"root");
   %Obj.removeBody();
}
if(isPackage(ewCorpses))
   deactivatepackage(ewCorpses);
package ewCorpses
{
   function GameConnection::onDeath(%client, %sourceObject, %sourceClient, %damageType, %damageArea) {
      if(!isObject(%client.player) || !isObject(%sourceObject) || !isObject(%sourceClient))
         return parent::onDeath(%client, %sourceObject, %sourceClient, %damageType, %damageArea);
         
      %body = new AIPlayer()
      {
         datablock = PlayerStandardArmor;
         corpse = 1;
         name = %client.name;
         killerName = %sourceClient.name;
      };
      %body.doLifeTick();
      
      if(!isObject(CorpseGroup))
         new SimGroup(CorpseGroup);
      CorpseGroup.add(%body);
      
      if(isObject(%img = %client.player.getMountedImage(0)))
         %body.mountImage(%img,0);
         
      %body.setTransform(%client.player.getTransform());
      %client.player.delete();
      
      ApplyBotParts(%client,%body);
      
      %body.playThread(3,"death1");
      
      parent::onDeath(%client, %sourceObject, %sourceClient, %damageType, %damageArea);
      
      %client.camera.setMode("Corpse",%body);
      
      %client.setControlObject(%client.camera);
      
      if(isObject(%client.corpse))
         %client.corpse.removeBody();
         
      %client.corpse = %body;
      %body.schedule(300000,doNiceRemove);
   }
   function Player::activateStuff(%this)
   {
      Parent::activateStuff(%this);
      %this.doCorpseClick();
   }
};
activatepackage(ewCorpses);
function servercmdClearCorpses(%c)
{
   if(!%c.isAdmin)
      return;
   if(!isObject(CorpseGroup))
      return;
   %z=CorpseGroup.getCount();
   if(%z==0)
      return;
   CorpseGroup.deleteAll();
   MessageAll('MsgClearBricks',"\c3"@%c.name@"\c0 cleared corpses ("@%z@")");
}